import sys
from pyparsing import *

from typing import TypeAlias

from pysmt.shortcuts import (TRUE, FALSE, And, Or, Not, Implies, Iff, Equals)
from pysmt.shortcuts import Symbol

from pysmt.fnode import FNode

# JUST DEFINE AN ALIAS FOR PYSMT

PropFormula: TypeAlias = FNode

# PARSING
ParserElement.enablePackrat()
sys.setrecursionlimit(3000)

TRUETK = Keyword("True")
FALSETK = Keyword("False")

identifier_chars = alphas + "_"
identifier_chars += alphanums
identifier = Word(identifier_chars)

operand = TRUETK | FALSETK | identifier

notop = Literal("!")
andop = Literal("&")
orop = Literal("|")
impliesop = Literal("->")
iffop =  Literal("<->")

TRUETK.setParseAction(lambda t : TRUE())
FALSETK.setParseAction(lambda t : FALSE()) 
identifier.setParseAction(lambda t : Symbol(t[0]))

class ParseBexp():
    def __init__(self):
        self.parser = infixNotation(
            operand,
            [
                (notop, 1, opAssoc.RIGHT, lambda t: Not(t[0][1])),
                (andop, 2, opAssoc.LEFT, lambda t : And(t[0][0],t[0][2])),
                (orop, 2, opAssoc.LEFT, lambda t : Or(t[0][0],t[0][2])),
                (impliesop, 2, opAssoc.LEFT, lambda t : Implies(t[0][0],t[0][2])),
                (iffop, 2, opAssoc.LEFT, lambda t : Iff(t[0][0],t[0][2])),
            ],
        )

    def parse(self, string):
        res = self.parser.parseString(string)
        return res[0]


 
