""" Run the emptiness checking for Non Deterministic Buchi Automata

"""

import sys, os

from parsita import Success,Failure

from mc308.data_structures.nba import NBA, nba_parse_from_goal
from mc308.data_structures.repr_nfa import nfa_to_dot


def main():

    directory = os.path.abspath("buchi")
    for filename in os.listdir(directory):
        if filename.endswith("gff.xml"):
            filepath = os.path.join(directory, filename)
            with open(filepath, 'r') as f:

                nba = nba_parse_from_goal(f)

                # Print NBA instance for verification
                print(nfa_to_dot(nba))

                is_empty, run = nba.is_empty()
                assert(not is_empty)

                if not is_empty:
                    print("Accepting run ", run)
                    is_run, trace = nba.is_run(run, True)
                    assert(is_run)
                    print("Trace ", trace)
                print()


if __name__ == "__main__":
    main()


